/*
 *
 * FvwmAmetista/fvwmmodule/FvwmModule.H --
 *
 * Copyright (C) Olivier Chapuis
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#ifndef FvwmModule_H_
#define FvwmModule_H_

#include "config.h"

#include <nucleo/core/ReactiveObject.H>
#include <nucleo/core/FileKeeper.H>

#include <X11/Xlib.h>

#include "wncdesktop/XwncWindow.H"
#include "wncdesktop/XwncDesktop.H"
#include "AFvwm.H"

class AScreen;

class FvwmModule : public ReactiveObject {
  
private:

  char *_myName;
	
  int _fd[2];
  FileKeeper *_fk;

  long _currentDesk;

  AScreen *_ascr;
  XwncDesktop *_wncDesktop;

  std::string _restartString ;

  void _processOperation(XwncWindow *xwncWin, char *rest);
  void _processMessage(FvwmPacket* packet);
  void _parseMessageLine(Window id, char *line);

protected:
  void react(Observable *);

public:

  FvwmModule(AScreen *ascr, XwncDesktop *wncDesktop,
		   int fd0, int fd1,
		   char *myName,
		   std::string restartString) ;

  void sendText(char *text, XwncWindow *win);
  
} ;

#endif
